#include "RenderChimp.h"
#include "SceneGraph.h"
#include "Geometry.h"

/*---------------------------------------------------------------------------*/

Geometry::Geometry(
		const char		*nname,
		NodeType_t		ntype
) : Transformable(nname, ntype)
{
	u32 i;

	for (i = 0; i < MAX_SHADER_LIGHT_SLOTS; i++)
		light[i] = 0;
}

/*---------------------------------------------------------------------------*/

Geometry::~Geometry()
{
}

/*---------------------------------------------------------------------------*/

void Geometry::setLight(
		Light					*nlight,
		u32						slot
	)
{
	light[slot] = nlight;
}

/*---------------------------------------------------------------------------*/

void Geometry::clearLight(
		u32						slot
	)
{
	light[slot] = 0;
}

/*---------------------------------------------------------------------------*/

Light *Geometry::getLight(
		u32						slot
	)
{
	return light[slot];
}

/*---------------------------------------------------------------------------*/

void Geometry::dereferenceLight(
		Light				*nlight
	)
{
	u32 i;
	Node *c = firstChild;

	for (i = 0; i < MAX_SHADER_LIGHT_SLOTS; i++) {

		if (light[i] == nlight)
			light[i] = 0;

	}

	while (c) {
		c->dereferenceLight(nlight);

		c = c->next;
	}
}

/*---------------------------------------------------------------------------*/

