/*
 * Defines a Light source node.
 * Inherits from Transformable.
 */

#ifndef __RC_LIGHT_H__
#define __RC_LIGHT_H__

class Light : public Transformable {
	friend class SceneGraph;
	friend class Geometry;

/*----------------------------------------------------------[ Functions ]----*/

	protected:
		Light(
				char	*nname
			);

		Light(
				char	*nname,
				rgbf	ncolor,
				f32		nintensity
			);

		~Light();

	public:
		void setColor(
				rgbf	ncolor
			);

		void setIntensity(
				f32		nintensity
			);

		void setFalloff(
				f32		nfalloff
			);

		rgbf getColor();

		f32 getIntensity();

		f32 getFalloff();

	private:

		Node *duplicateSelf();

/*------------------------------------------------------------[ Members ]----*/

	public:
		rgbf		color;
		f32			intensity;
		f32			falloff;

};


#endif /* __RC_LIGHT_H__ */

