/* Simple, textured material */

#ifndef __RC_MATERIALTEXTURED_H__
#define __RC_MATERIALTEXTURED_H__

class MaterialTextured : public Material {
	friend class SceneGraph;
	friend class Material;

/*----------------------------------------------------------[ Functions ]----*/

	private:
		MaterialTextured(
				const char		*nidentifier,
				u32				purge_level
			);

		virtual ~MaterialTextured();

	public:

		/* Diffuse texture */

		void setTexture(
				Texture				*tex,

				bool				instantiate_resource
			);

		void setTexture(
				const char			*filename,

				u32					purge_level
			);

		Texture *getTexture();

		Resource *clone(
				const char			*clone_name,

				u32					purge_level
			);

	protected:
		void prepareMaterial(
				FrameInfo_t			*di,
				Geometry			*geometry
			);

/*------------------------------------------------------------[ Members ]----*/

	private:
		Texture			*texture;

};


#endif /* __RC_MATERIALTEXTURED_H__ */

