#include <cstring>
#include "RenderChimp.h"
#include "Misc.h"

/*---------------------------------------------------------------------------*/

u32 calculateStringHash(
		const char		*str
	)
{
	u32 len = strlen(str);
	u32 i;

	u32 hash = 0;

	for (i = 0; i < len; i++) {
		hash *= 33;
		hash += (u32) str[i];
	}

	return hash;
}

/*---------------------------------------------------------------------------*/

#ifdef MEMORY_DEBUG

char *duplicateStringDebug(
		const char		*str,
		const char		*file,
		const char		*func,
		i32				line
	)
{
	u32 len = strlen(str);
	char *s = (char *) MemoryAllocateDebug((sizeof(char) * (len + 1)), file, func, line);
	s[len] = '\0';

	strncpy(s, str, len);

	return s;
}

#else /* MEMORY_DEBUG */

char *duplicateString(
		const char		*str
	)
{
	u32 len = strlen(str);
	char *s = (char *) malloc(sizeof(char) * (len + 1));
	s[len] = '\0';

	strncpy(s, str, len);

	return s;
}

#endif /* MEMORY_DEBUG */

/*---------------------------------------------------------------------------*/

