/*
 * Misc. useful functions
 */

#ifndef __RC_MISC_H__
#define __RC_MISC_H__

#define	PAD4(a)				((((a) - 1) & (~0x3)) + 0x4)

/* Calculates a hash value from a string */
u32 calculateStringHash(
		const char		*str
	);


/* Allocates new memory and occupies it with the string */
#ifdef MEMORY_DEBUG

	#define duplicateString(str)	duplicateStringDebug((str), __FILE__, __FUNCTION__, __LINE__)

	char *duplicateStringDebug(
			const char		*str,
			const char		*file,
			const char		*func,
			i32				line
		);
#else /* MEMORY_DEBUG */
	char *duplicateString(
			const char		*str
		);
#endif /* MEMORY_DEBUG */



#endif /* __RC_MISC_H__ */


