attribute vec3 Vertex;
attribute vec3 Normal;

uniform vec3 ViewPosition;
uniform mat4 World;
uniform mat4 WorldViewProjection;
uniform mat4 WorldInverseTranspose;

uniform samplerCube EnvSampler;

	// To fragment shader

varying mediump	vec3 worldPosition;
varying mediump	vec3 worldNormal;
varying mediump	vec3 viewVector;


void main() {

		// Setup
	worldPosition = (World * vec4(Vertex.xyz, 1.0)).xyz;
	worldNormal = (WorldInverseTranspose * vec4(Normal.xyz, 1.0)).xyz;
	viewVector = normalize(ViewPosition - worldPosition);

		// Position
	gl_Position = WorldViewProjection * vec4(Vertex.xyz, 1.0);

}

